"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CountVisitor = CountVisitor;
const graphql_1 = require("graphql");
let counts = {};
function CountVisitor(context) {
    return {
        enter(node) {
            if (node.kind === graphql_1.Kind.DOCUMENT) {
                counts = Object.create(null);
            }
            if (counts[node.kind] === undefined) {
                counts[node.kind] = 1;
            }
            else {
                counts[node.kind]++;
            }
        },
        leave(node) {
            if (node.kind === graphql_1.Kind.DOCUMENT) {
                context.addMeta("count", counts);
            }
        },
    };
}
