import type { GraphQLErrorOptions } from "graphql";
import { GraphQLError } from "graphql";
import type { ErrorOperationLocation, RuleFormattedError } from "./interfaces";
import type { RulesContext } from "./rulesContext";
export interface RuleErrorOptions extends GraphQLErrorOptions {
    infraction: string;
    /** What needs to be added to the overrides for this coordinate for this error to be ignored? */
    override: GraphileConfig.GraphQLCheckConfig;
    errorOperationLocations?: readonly ErrorOperationLocation[];
}
export declare class RuleError extends GraphQLError {
    options: RuleErrorOptions;
    constructor(message: string, options: RuleErrorOptions);
    toJSONEnhanced(context: RulesContext): RuleFormattedError;
}
